<?php
/**
 * Kahanit Framework for PrestaShop Modules by Kahanit
 *
 * Kahanit Framework by Kahanit(http://www.kahanit.com)
 * is licensed under a Creative Creative Commons Attribution-NoDerivatives 4.0
 * International License. Based on a work at http://www.kahanit.com.
 * Permissions beyond the scope of this license may be available at http://www.kahanit.com.
 * To view a copy of this license, visit http://creativecommons.org/licenses/by-nd/4.0/.
 *
 * @author    Amit Sidhpura <amit@kahanit.com>
 * @copyright 2016 Kahanit
 * @license   http://creativecommons.org/licenses/by-nd/4.0/
 */

if (!class_exists('KIHelpers')) {
    /**
     * Class KIHelpers
     */
    class KIHelpers
    {
        public static function filterSearchQuery($search_query = '', $keys = array())
        {
            $search_query = trim($search_query);
            $search_items = array();

            foreach ($keys as $key) {
                $pattern = '/' . $key . '\s*:\s*[^:]*((?=' . implode('\s*:)|(?=', $keys) . '\s*:)|($))/i';
                preg_match($pattern, $search_query, $matches);

                if (isset($matches[0])) {
                    $search_value = preg_replace('/\s+/', ' ', $matches[0]);
                } else {
                    $search_value = '';
                }

                $search_value = explode(':', $search_value);
                $search_items[$key] = end($search_value);
                $search_items[$key] = trim($search_items[$key]);
            }

            $search_items['query'] = $search_query;

            return $search_items;
        }

        public static function getLibrary($library, $module)
        {
            include_once _PS_MODULE_DIR_ . $module->name . '/' . 'libraries/' . $library . '.php';
        }

        public static function stripslashes($string)
        {
            if (_PS_MAGIC_QUOTES_GPC_) {
                $string = Tools::stripslashes($string);
            } else {
                $search = array("\\", "\0", "\r", "\x1a", "'", '"');
                $replace = array("\\\\", "\\0", "\\r", "\Z", "\'", '\"');

                $string = str_replace($replace, $search, $string);
            }

            return $string;
        }

        public static function getAdminLink($controller, $with_token = true, $params = array())
        {
            $id_lang = Context::getContext()->language->id;

            if ($with_token) {
                $params['token'] = Tools::getAdminTokenLite($controller);
            }

            return Dispatcher::getInstance()->createUrl($controller, $id_lang, $params, false);
        }
    }
}
